using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_Area
    /// </summary>
    public partial class T_Sys_Area
    {
        public T_Sys_Area()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_AreaId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Area");
            strSql.Append(" where F_AreaId=@F_AreaId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AreaId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_AreaId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_Area model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Area(");
            strSql.Append("F_AreaName,F_Sort,F_PrentId,F_CreateDate,F_State,F_CreateUser)");
            strSql.Append(" values (");
            strSql.Append("@F_AreaName,@F_Sort,@F_PrentId,@F_CreateDate,@F_State,@F_CreateUser)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AreaName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_PrentId", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50)};
            parameters[0].Value = model.F_AreaName;
            parameters[1].Value = model.F_Sort;
            parameters[2].Value = model.F_PrentId;
            parameters[3].Value = model.F_CreateDate;
            parameters[4].Value = model.F_State;
            parameters[5].Value = model.F_CreateUser;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_Area model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Area set ");
            strSql.Append("F_AreaName=@F_AreaName,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_PrentId=@F_PrentId,");
            strSql.Append("F_CreateDate=@F_CreateDate,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_CreateUser=@F_CreateUser");
            strSql.Append(" where F_AreaId=@F_AreaId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AreaName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_PrentId", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_AreaId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_AreaName;
            parameters[1].Value = model.F_Sort;
            parameters[2].Value = model.F_PrentId;
            parameters[3].Value = model.F_CreateDate;
            parameters[4].Value = model.F_State;
            parameters[5].Value = model.F_CreateUser;
            parameters[6].Value = model.F_AreaId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_AreaId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Area ");
            strSql.Append(" where F_AreaId=@F_AreaId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AreaId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_AreaId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_AreaIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Area ");
            strSql.Append(" where F_AreaId in (" + F_AreaIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Area GetModel(int F_AreaId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_AreaId,F_AreaName,F_Sort,F_PrentId,F_CreateDate,F_State,F_CreateUser from T_Sys_Area ");
            strSql.Append(" where F_AreaId=@F_AreaId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AreaId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_AreaId;

            CallCenterApi.Model.T_Sys_Area model = new CallCenterApi.Model.T_Sys_Area();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Area DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_Area model = new CallCenterApi.Model.T_Sys_Area();
            if (row != null)
            {
                if (row["F_AreaId"] != null && row["F_AreaId"].ToString() != "")
                {
                    model.F_AreaId = int.Parse(row["F_AreaId"].ToString());
                }
                if (row["F_AreaName"] != null)
                {
                    model.F_AreaName = row["F_AreaName"].ToString();
                }
                if (row["F_Sort"] != null && row["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(row["F_Sort"].ToString());
                }
                if (row["F_PrentId"] != null && row["F_PrentId"].ToString() != "")
                {
                    model.F_PrentId = int.Parse(row["F_PrentId"].ToString());
                }
                if (row["F_CreateDate"] != null && row["F_CreateDate"].ToString() != "")
                {
                    model.F_CreateDate = DateTime.Parse(row["F_CreateDate"].ToString());
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere, string filedOrder = "")
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_AreaId,F_AreaName,F_Sort,F_PrentId,F_CreateDate,F_State,F_CreateUser ");
            strSql.Append(" FROM T_Sys_Area ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            if (filedOrder.Trim() != "")
            {
                strSql.Append(" order by " + filedOrder);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_AreaId,F_AreaName,F_Sort,F_PrentId,F_CreateDate,F_State,F_CreateUser ");
            strSql.Append(" FROM T_Sys_Area ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Area ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_AreaId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Area T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_Area";
			parameters[1].Value = "F_AreaId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

